com.fasterxml.jackson.databind.type

## Class ArrayType

- java.lang.Object
- - com.fasterxml.jackson.core.type.ResolvedType
  - - com.fasterxml.jackson.databind.JavaType
    - - com.fasterxml.jackson.databind.type.TypeBase
      - - com.fasterxml.jackson.databind.type.ArrayType

All Implemented Interfaces:
  JsonSerializable, Serializable, Type

    public final class ArrayType
    extends TypeBase

Array types represent Java arrays, both primitive and object valued. Further, Object-valued arrays can have element type of any other legal `JavaType`.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.JsonSerializable

`JsonSerializable.Base`

### Field Summary

Fields
`protected JavaType` `_componentType` Type of elements in the array.
`protected Object` `_emptyArray` We will also keep track of shareable instance of empty array, since it usually needs to be constructed any way; and because it is essentially immutable and thus can be shared.

### Fields inherited from class com.fasterxml.jackson.databind.type.TypeBase

`_bindings, _superClass, _superInterfaces`

### Fields inherited from class com.fasterxml.jackson.databind.JavaType

`_asStatic, _class, _hash, _typeHandler, _valueHandler`

### Constructor Summary

Constructors
`protected` `ArrayType(JavaType componentType, TypeBindings bindings, Object emptyInstance, Object valueHandler, Object typeHandler, boolean asStatic)`

### Method Summary

Methods
`protected JavaType` `_narrow(Class<?> subclass)` Deprecated.
`static ArrayType` `construct(JavaType componentType, TypeBindings bindings)`
`static ArrayType` `construct(JavaType componentType, TypeBindings bindings, Object valueHandler, Object typeHandler)`
`boolean` `equals(Object o)`
`JavaType` `getContentType()`
`Object` `getContentTypeHandler()`
`Object` `getContentValueHandler()`
`StringBuilder` `getErasedSignature(StringBuilder sb)` Method for accessing signature without generic type information, in form compatible with all versions of JVM, and specifically used for type descriptions when generating byte code.
`StringBuilder` `getGenericSignature(StringBuilder sb)`
`boolean` `hasGenericTypes()`
`boolean` `isAbstract()` For some odd reason, modifiers for array classes would claim they are abstract types.
`boolean` `isArrayType()`
`boolean` `isConcrete()` For some odd reason, modifiers for array classes would claim they are abstract types.
`boolean` `isContainerType()`
`JavaType` `refine(Class<?> contentClass, TypeBindings bindings, JavaType superClass, JavaType[] superInterfaces)` Mutant factory method that will try to create and return a sub-type instance for known parameterized types; for other types will return `null` to indicate that no just refinement makes necessary sense, without trying to detect special status through implemented interfaces.
`String` `toString()`
`JavaType` `withContentType(JavaType contentType)` Mutant factory method that may be called on structured types that have a so-called content type (element of arrays, value type of Maps, referenced type of referential types), and will construct a new instance that is identical to this instance, except that it has specified content type, instead of current one.
`ArrayType` `withContentTypeHandler(Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content type (element type for arrays, value type for Maps and so forth) handler assigned.
`ArrayType` `withContentValueHandler(Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.
`ArrayType` `withStaticTyping()` Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use.
`ArrayType` `withTypeHandler(Object h)` "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.
`ArrayType` `withValueHandler(Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.

### Methods inherited from class com.fasterxml.jackson.databind.type.TypeBase

`_bogusSuperClass, _classSignature, buildCanonicalName, containedType, containedTypeCount, containedTypeName, findSuperType, findTypeParameters, getBindings, getInterfaces, getSuperClass, getTypeHandler, getValueHandler, serialize, serializeWithType, toCanonical`

### Methods inherited from class com.fasterxml.jackson.databind.JavaType

`containedTypeOrUnknown, forcedNarrowBy, getErasedSignature, getGenericSignature, getKeyType, getParameterSource, getRawClass, getReferencedType, hasContentType, hashCode, hasRawClass, hasValueHandler, isCollectionLikeType, isEnumType, isFinal, isInterface, isJavaLangObject, isMapLikeType, isPrimitive, isThrowable, isTypeOrSubTypeOf, useStaticType`

### Methods inherited from class com.fasterxml.jackson.core.type.ResolvedType

`isReferenceType`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### _componentType

    protected final JavaType _componentType

Type of elements in the array.

#### _emptyArray

    protected final Object _emptyArray

We will also keep track of shareable instance of empty array, since it usually needs to be constructed any way; and because it is essentially immutable and thus can be shared.

### Constructor Detail

#### ArrayType

    protected ArrayType(JavaType componentType,
             TypeBindings bindings,
             Object emptyInstance,
             Object valueHandler,
             Object typeHandler,
             boolean asStatic)

### Method Detail

#### construct

    public static ArrayType construct(JavaType componentType,
                      TypeBindings bindings)

#### construct

    public static ArrayType construct(JavaType componentType,
                      TypeBindings bindings,
                      Object valueHandler,
                      Object typeHandler)

#### withContentType

    public JavaType withContentType(JavaType contentType)

Description copied from class: `JavaType`
Mutant factory method that may be called on structured types that have a so-called content type (element of arrays, value type of Maps, referenced type of referential types), and will construct a new instance that is identical to this instance, except that it has specified content type, instead of current one. If content type is already set to given type, `this` is returned. If type does not have a content type (which is the case with `SimpleType`), `IllegalArgumentException` will be thrown.

Specified by:
  `withContentType` in class `JavaType`
Returns:
  Newly created type instance

#### withTypeHandler

    public ArrayType withTypeHandler(Object h)

Description copied from class: `JavaType`
"Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.

Specified by:
  `withTypeHandler` in class `JavaType`
Returns:
  Newly created type instance

#### withContentTypeHandler

    public ArrayType withContentTypeHandler(Object h)

Description copied from class: `JavaType`
Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content type (element type for arrays, value type for Maps and so forth) handler assigned.

Specified by:
  `withContentTypeHandler` in class `JavaType`
Returns:
  Newly created type instance, with given

#### withValueHandler

    public ArrayType withValueHandler(Object h)

Description copied from class: `JavaType`
Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.

Specified by:
  `withValueHandler` in class `JavaType`
Returns:
  Newly created type instance

#### withContentValueHandler

    public ArrayType withContentValueHandler(Object h)

Description copied from class: `JavaType`
Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.

Specified by:
  `withContentValueHandler` in class `JavaType`
Returns:
  Newly created type instance

#### withStaticTyping

    public ArrayType withStaticTyping()

Description copied from class: `JavaType`
Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use. The main use case is to allow forcing of specific root value serialization type, and specifically in resolving serializers for contained types (element types for arrays, Collections and Maps).

Specified by:
  `withStaticTyping` in class `JavaType`

#### _narrow

    @Deprecated
    protected JavaType _narrow(Class<?> subclass)

Deprecated.
Handling of narrowing conversions for arrays is trickier: for now, it is not even allowed.

Specified by:
  `_narrow` in class `JavaType`

#### refine

    public JavaType refine(Class<?> contentClass,
                  TypeBindings bindings,
                  JavaType superClass,
                  JavaType[] superInterfaces)

Description copied from class: `JavaType`
Mutant factory method that will try to create and return a sub-type instance for known parameterized types; for other types will return `null` to indicate that no just refinement makes necessary sense, without trying to detect special status through implemented interfaces.

Specified by:
  `refine` in class `JavaType`

#### isArrayType

    public boolean isArrayType()

Overrides:
  `isArrayType` in class `JavaType`

#### isAbstract

    public boolean isAbstract()

For some odd reason, modifiers for array classes would claim they are abstract types. Not so, at least for our purposes.

Overrides:
  `isAbstract` in class `JavaType`

#### isConcrete

    public boolean isConcrete()

For some odd reason, modifiers for array classes would claim they are abstract types. Not so, at least for our purposes.

Overrides:
  `isConcrete` in class `JavaType`

#### hasGenericTypes

    public boolean hasGenericTypes()

Overrides:
  `hasGenericTypes` in class `JavaType`

#### isContainerType

    public boolean isContainerType()

Specified by:
  `isContainerType` in class `JavaType`
Returns:
  True if type represented is a container type; this includes array, Map and Collection types.

#### getContentType

    public JavaType getContentType()

Overrides:
  `getContentType` in class `JavaType`

#### getContentValueHandler

    public Object getContentValueHandler()

Overrides:
  `getContentValueHandler` in class `JavaType`

#### getContentTypeHandler

    public Object getContentTypeHandler()

Overrides:
  `getContentTypeHandler` in class `JavaType`

#### getGenericSignature

    public StringBuilder getGenericSignature(StringBuilder sb)

Specified by:
  `getGenericSignature` in class `TypeBase`
Parameters:
  `sb` - StringBuilder to append signature to
Returns:
  StringBuilder that was passed in; returned to allow call chaining

#### getErasedSignature

    public StringBuilder getErasedSignature(StringBuilder sb)

Description copied from class: `JavaType`
Method for accessing signature without generic type information, in form compatible with all versions of JVM, and specifically used for type descriptions when generating byte code.

Specified by:
  `getErasedSignature` in class `TypeBase`
Parameters:
  `sb` - StringBuilder to append signature to
Returns:
  StringBuilder that was passed in; returned to allow call chaining

#### toString

    public String toString()

Specified by:
  `toString` in class `JavaType`

#### equals

    public boolean equals(Object o)

Specified by:
  `equals` in class `JavaType`